/*
 *  Startup Code for MIPS32 CPU-core
 *
 *  Copyright (c) 2003	Wolfgang Denk <wd@denx.de>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */


#include <config.h>
#include <version.h>
#include <asm/regdef.h>
#include <asm/mipsregs.h>



	.set noreorder

	.globl _start
	.text
_start:
        b reset		/* U-boot entry point,  ROM  Address :0xBFC0 0000 */
	nop 		/* Next 256 * 4 = 1024 (0x400) are nop , as RAM based Vector table is used */ 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	nop 
	.align 4
/*
* Reset : We DONT  use hardware based autoload feature to select the primary or backbup uboot  . 
*	  This is decided based on GPIO pins P0_9 
*
*        P0_9  SP Interpretation
*		  1     Boot Primary Image   ( 0xBFC1 0000 )
*	      0     Boot Backup Image	 ( 0xBFD1 0000 )
*
*	  
*       
*/

reset : 	            	/* ROM Address 0xBFC0 4000 */
	li	$8, 0xbfc0ffff         /* Address of partition select byte */
	lb	$9, 0 ($8)            /* Load byte from end of NOR tiny */
	li	$10, 0x00000001         /* Load bitmask for bottom bit */
	and	$12, $9, $10           /* Bitmask partition bit, store in $12 */

	li	$8, 0xB0200800	    /* Load P0 Register addr in register $8	*/
	lw	$9, 0 ($8)		/* load P0 Register value into register $9 */
	li	$10, 0x00000200		/* load value bit with 9 high in register $10 */
	and	$11, $9, $10		/* Store the result in the register file $11 */
	srl $13, $11, 9			/* Shift result to bit zero */

	beq	$12, $13, UBOOT_TOP	/*  P0_9  is  high */
	nop

	li	$14, 0xbfd10000	        /* Address of the bottom NOR partition */
	jr	$14		/* Boot bottom NOR Image  */
	nop

UBOOT_TOP:
	
	li	$14, 0xbfc10000	        /* Address of the top NOR partition */
	jr	$14		/*  Boot top NOR Image  */
	nop

  .asciiz "VERSION=BootBlock 3.0\n"





