#ifndef __GPIO_INFO_
#define __GPIO_INFO_

/* common  declarations for the gpio */
#define GPIO_DIR_OUT_DAT_HIGH 2
#define GPIO_DIR_OUT_DAT_LOW  1
#define GPIO_DIR_OD_OUT 2
#define GPIO_DIR_OUT   1
#define GPIO_DIR_IN    0
#define GPIO_POL_HIGH  1
#define GPIO_POL_LOW   0
#define GPIO_DATA_HIGH 1
#define GPIO_DATA_LOW  0

/* Only direct line ports for now */
#define MAX_GPIO_PORTS			5
#define PORT_0				0
#define PORT_1				1
#define PORT_2				2
#define PORT_3				3
#define PORT_4				4

#define GPIO_SIZE			512  //bytes

/* GPIO Port Base Address */
/* GPIO Port Base Address */
#define GPIO_PORT0                              0x10200a00
#define GPIO_BASE_OFFSET                (0xa0000000 + GPIO_PORT0)
#define GPIO_PIN_ADDR_UNIT              0x04


/************ GPIO Port Bit Control   ****************/
#define OUTPUT_LOW                      0x00000000
#define OUTPUT_HIGH                     0x00000001
#define INPUT_INTR_DISABLE      0x00000003
#define INPUT_INTR_RISE_EDGE		0x00000006
#define INPUT_INTR_FALL_EDGE		0x0000000A
#define INPUT_INTR_BOTH_EDGE		0x0000000E


/* GPIO Mapping Table */
typedef struct
{
        unsigned short VirtualPin;
        unsigned short PhysicalPin;
        unsigned char  Direction;
        unsigned char  Value;
}  __attribute__((packed)) GPIO_MAP_TABLE;

/****This is the structure that is passed back and forth between userspace and driver as an ioctl arg*****/
typedef struct
{
        unsigned short PinNum; /* Not used in case of interrupt sensor data */
        unsigned char  data; /* Direction or Value or Polarity */
}  __attribute__((packed)) Gpio_data_t;

/*** Gpio Device Private data**************** */

typedef struct {
    void     *gpio_addr;
}  __attribute__((packed)) gpio_dev_t;

/* GPIO PORT - PIN Mapping Table */
/* Mapping between pin number, GPIO Port number and the pin within the port */
typedef struct
{
        unsigned char PinNumber; /* External Pin number (GPIO_0 - GPIO_79) */
        unsigned char PortNumber; /* Port Number (0 - 15) */
        unsigned char PortPinNumber; /* Pin number (0 - 4) within that port */
}  __attribute__((packed)) GPIO_PORT_PIN_MAPPING;

#define MAX_GPIOS                       80
#define MAX_GPIO_PORTS          5

#define GPIO_0          0
#define GPIO_1          1
#define GPIO_2          2
#define GPIO_3          3
#define GPIO_4          4
#define GPIO_5          5
#define GPIO_6          6
#define GPIO_7          7
#define GPIO_8          8
#define GPIO_9          9
#define GPIO_10         10
#define GPIO_11         11
#define GPIO_12         12
#define GPIO_13         13
#define GPIO_14         14
#define GPIO_15         15
#define GPIO_16         16
#define GPIO_17         17
#define GPIO_18         18
#define GPIO_19         19
#define GPIO_20         20
#define GPIO_21         21
#define GPIO_22         22
#define GPIO_23         23
#define GPIO_24         24
#define GPIO_25         25
#define GPIO_26         26
#define GPIO_27         27
#define GPIO_28         28
#define GPIO_29         29
#define GPIO_30         30
#define GPIO_31         31
#define GPIO_32         32
#define GPIO_33         33
#define GPIO_34         34
#define GPIO_35         35
#define GPIO_36         36
#define GPIO_37         37
#define GPIO_38         38
#define GPIO_39         39
#define GPIO_40         40
#define GPIO_41         41
#define GPIO_42         42
#define GPIO_43         43
#define GPIO_44         44
#define GPIO_45         45
#define GPIO_46         46
#define GPIO_47         47
#define GPIO_48         48
#define GPIO_49         49
#define GPIO_50         50
#define GPIO_51         51
#define GPIO_52         52
#define GPIO_53         53
#define GPIO_54         54
#define GPIO_55         55
#define GPIO_56         56
#define GPIO_57         57
#define GPIO_58         58
#define GPIO_59         59
#define GPIO_60         60
#define GPIO_61         61
#define GPIO_62         62
#define GPIO_63         63
#define GPIO_64         64
#define GPIO_65         65
#define GPIO_66         66
#define GPIO_67         67
#define GPIO_68         68
#define GPIO_69         69
#define GPIO_70         70
#define GPIO_71         71
#define GPIO_72         72
#define GPIO_73         73
#define GPIO_74         74
#define GPIO_75         75
#define GPIO_76         76
#define GPIO_77         77
#define GPIO_78         78
#define GPIO_79         79

#endif // __GPIO_INFO_
